// Fraktaltyp Complex Newton
// l[0] = Exponent
#include <stdio.h>
#include <stdlib.h>
#include <complex.h>
#include <klocale.h>
#include "c_newton.h"

double ComplexNewtonPar[4] = {5,0,1,0};

void ComplexNewton::Init(int SizeX, int SizeY)
{
int i;

   BaseFract::Init(SizeX, SizeY);
   SetDefaultCorners(&li,&re,&un,&ob);
   for (i=0; i<16;i++) p[i]=SetDefaultParams(i);
   SetSize(SizeX, SizeY);
}

void ComplexNewton::SetDefaultCorners(double *x1, double *x2, double *y1, double *y2)
{
   *x1 = -2;     // Gre des Fraktals
   *x2 =  2;
   *y1 = -1.5;
   *y2 =  1.5;
}

double ComplexNewton::SetDefaultParams(int i)
{
   if ((i>=0)&&(i<=3)) return ComplexNewtonPar[i];
   else  return 0.0;
}

int ComplexNewton::CalcPoint(int x, int y)
{
double rx = li+dx*x;
double ry = un+dy*y;
complex<double> Z,z,h,P,R,P1;
//double P=p[0];
int iter=0;

   Z=complex<double>(rx,ry);
   P=complex<double>(p[0],p[1]);
   R=complex<double>(p[2],p[3]);
   P1=P-1.0;
   do {
      z=Z;
      Z=(P1*pow(z,P)+R)/(P*pow(z,P1));
      //Z=((P-1)*pow(z,P)+1)/(P*pow(z,(P-1)));
      //Z = (2*z*z*z+1)/(3*z*z);
      iter++;
      h=(Z-z);
   } while ( (iter<MaxIter) && ( fabs(norm(h))>0.000001));
   return PostCompute(iter,h.real(),h.imag());
//   return iter;
}

const char* ComplexNewton::GetFracInfo(void)
{
   return "Complexe Newton Nullstellensuche";
}

int ComplexNewton::SetupFrac(BaseFract* Frac) // type specific-setup
{
GenericDlg GDlg(Frac, 0, "Complex Newton Settings");

   GDlg.SetHeader(i18n("Polynomial Degree p and Complex Root r"));
   GDlg.SetParameterNum(4);
   GDlg.SetParameterText(0,"p Real Part");
   GDlg.SetParameterText(1,"p Imaginary Part");
   GDlg.SetParameterText(2,"r Real Part");
   GDlg.SetParameterText(3,"r Imaginary Part");

   if (GDlg.exec()) {
      return GDlg.SetSpecificParams();
   } else
      return FALSE;
}
