#include <stdio.h>
#include <iostream.h>
#include <qgroupbox.h>
#include "dlgjourney.h"
#include "parameter.h"
#include "kmandel.h"

#define PREVIEW 0
#define FULL 1

extern QDir MandelDir;
extern KMandel *kmand; 
extern int NoResize;

QList<ListType> DataList;

JourneyDlg::JourneyDlg(DrawWidget *C, QWidget* parent=0, const char* name=0):
     QDialog (parent, name, TRUE)
{
QString Strg;

   Client=C;
   setFixedSize(450,370);
   setCaption(i18n("Make Journey"));
   List=NULL;
   Art=PREVIEW;

   QLabel* Label1 = new QLabel(i18n("Top Level File"), this, "Label1");
   Label1->setGeometry(10,50,150,20);
   StartFileEdit = new QLineEdit(this, "StartFileEdit");
   StartFileEdit->setGeometry(10,75,350,25);
   SuchBtn = new QPushButton("", this, "SuchBtn");
   SuchBtn->setGeometry(375,75,25,25);
   SuchBtn->setPixmap(BarIcon("fileopen.xpm"));
   connect(SuchBtn, SIGNAL(clicked()), SLOT(SuchBtnClicked()) );
   
   QLabel* Label2 = new QLabel(i18n("Output Dir"), this, "Label2");
   Label2->setGeometry(10,110,150,20);
   OutDirEdit = new QLineEdit(this, "OutDirEdit");
   OutDirEdit->setGeometry(10,135,350,25);
   OutDirEdit->setText(MandelDir.absPath());
   DirSuchBtn = new QPushButton("", this, "DirSuchBtn");
   DirSuchBtn->setGeometry(375,135,25,25);
   DirSuchBtn->setPixmap(BarIcon("fileopen.xpm"));
   connect(DirSuchBtn, SIGNAL(clicked()), SLOT(DirSuchBtnClicked()) );
   
   
   QGroupBox *PrevGrp = new QGroupBox(i18n("Preview"), this, "PrevGrp");
   PrevGrp->setGeometry(10,170,200,130);
   QLabel *PrevXSize = new QLabel(i18n("SizeX"), PrevGrp, "PrevXSize");
   PrevXSize->setGeometry(10,20,80,20);
   PrevXSpin = new QSpinBox(PrevGrp, "PrevXSpin");
   PrevXSpin->setGeometry(10,50,80,25);
   PrevXSpin->setRange(5,65536);
   PrevXSpin->setValue(240);
   //PrevXSpin->setEditable(TRUE);
   QLabel *PrevYSize = new QLabel(i18n("SizeY"), PrevGrp, "PrevYSize");
   PrevYSize->setGeometry(100,20,80,20);
   PrevYSpin = new QSpinBox(PrevGrp, "PrevYSpin");
   PrevYSpin->setGeometry(100,50,80,25);
   PrevYSpin->setRange(5,65536);
   PrevYSpin->setValue(180);
   //PrevYSpin->setEditable(TRUE);
   PrevSet = new QPushButton(i18n("Set"), PrevGrp, "PrevSet");
   PrevSet->setGeometry(10,90,80,25);
   connect(PrevSet, SIGNAL(clicked()), this, SLOT(PrevSetClick()));
   PrevStart = new QPushButton(i18n("Start"), PrevGrp, "PrevStart");
   PrevStart->setGeometry(100,90,80,25);
   connect(PrevStart, SIGNAL(clicked()), this, SLOT(PrevStartClick()));

   QGroupBox *FullGrp = new QGroupBox(i18n("Full Size"), this, "FullGrp");
   FullGrp->setGeometry(230,170,200,130);
   QLabel *FullXSize = new QLabel(i18n("SizeX"), FullGrp, "FullXSize");
   FullXSize->setGeometry(10,20,80,20);
   FullXSpin = new QSpinBox(FullGrp, "FullXSpin");
   FullXSpin->setGeometry(10,50,80,25);
   FullXSpin->setRange(5,65536);
   FullXSpin->setValue(800);
   //FullXSpin->setEditable(TRUE);
   QLabel *FullYSize = new QLabel(i18n("SizeY"), FullGrp, "FullYSize");
   FullYSize->setGeometry(100,20,80,20);
   FullYSpin = new QSpinBox(FullGrp, "FullYSpin");
   FullYSpin->setGeometry(100,50,80,25);
   FullYSpin->setRange(5,65536);
   FullYSpin->setValue(600);
   //FullYSpin->setEditable(TRUE);
   FullSet = new QPushButton(i18n("Set"), FullGrp, "FullSet");
   FullSet->setGeometry(10,90,80,25);
   connect(FullSet, SIGNAL(clicked()), this, SLOT(FullSetClick()));
   FullStart = new QPushButton(i18n("Start"), FullGrp, "FullStart");
   FullStart->setGeometry(100,90,80,25);
   connect(FullStart, SIGNAL(clicked()), this, SLOT(FullStartClick()));

   FullCheck = new QCheckBox(i18n("Include fullsize Images"), this, "FullCheck");
   FullCheck->setGeometry(10,310,200,20);
   FullCheck->setChecked(TRUE);
   
   ReadmeBtn = new QPushButton(i18n("Important"), this, "ReadmeBtn");
   ReadmeBtn->setGeometry(50,15, 80,30);
   ReadmeBtn->setFont( QFont("Helvetica", 12, QFont::Bold) );
   connect(ReadmeBtn, SIGNAL(clicked()), SLOT(ReadmeBtnClick()) );

   StopBtn = new QPushButton(i18n("Stop"), this, "StopBtn");
   StopBtn->setGeometry(width()-200 ,height()-50,80,30);
   connect(StopBtn, SIGNAL(clicked()), SLOT(StopBtnClick()) );
   StopBtn->setEnabled(FALSE);
   
   CloseBtn = new QPushButton(i18n("Close"), this, "CloseBtn");
   CloseBtn->setGeometry(width()-100 ,height()-50,80,30);
   connect(CloseBtn, SIGNAL(clicked()), SLOT(accept()) );
   
   Running=FALSE;
   connect(kmand->Client, SIGNAL(FertigSig()), this, SLOT(FertigSlot()));

}

void JourneyDlg::SuchBtnClicked() {
   QString f;
   if (strlen(StartFileEdit->text())!=0)
      f=StartFileEdit->text();
   else
      f=MandelDir.absPath();
   f = KFileDialog::getOpenFileName(f, "*.par", this );
   if ( !f.isEmpty() ) {
      StartFileEdit->setText(f);
   };
}

void JourneyDlg::DirSuchBtnClicked() {
   debug ("DirSuchBtnClicked");
   //QString f = KDirDialog::getDirectory(OutDirEdit->text(), this, "OutDirSel");
   QString f = KFileDialog::getExistingDirectory(OutDirEdit->text(), this, "SetiDirSel");
   if ( !f.isEmpty() )
      OutDirEdit->setText(f);
}

void JourneyDlg::StartJourney(int iArt) {
QDir TestDir;
struct MandDataType MD;
int Res,Pos;
short FracType;
unsigned Lauf;
ParameterFile *Par;
ListType* EndePtr, *Ptr, *Such;
QString *Datei;

   debug("Start");
   Art=iArt;
   StartFile = StartFileEdit->text();
   OutDir = OutDirEdit->text();
   if (!QFile::exists(StartFile)) {
      QMessageBox::information(this,i18n("Error"),
                      i18n("StartFile doesn't exist."),
                      i18n("OK"),0,0,0);
      return;
   }
   if (OutDir.right(1)!="/")
      OutDir += "/";
   TestDir = OutDir;
   if (!TestDir.exists()) {
      QMessageBox::information(this,i18n("Error"),
                      i18n("OutDir doesn't exist."),
                      i18n("OK"),0,0,0);
      return;
   }
   InDir = StartFile.data(); // Bock??
   Pos = InDir.findRev("/");
   if (Pos>0)
      InDir.truncate(Pos+1);

   EndePtr=NULL;
   List=NULL;
   FracType=-1;
   
   Par=new ParameterFile(StartFile.data());
   Res = Par->Open(PAR_READ);
   if (Res==PAR_OK) {
      Res = Par->BlockSize('M','U');
      if (Res<=0) {
         QMessageBox::information(this,i18n("Error"),
                         i18n("TopFile is no MU-File"),
                         i18n("OK"),0,0,0);
         return;
      }
      Res = Par->ReadBlock('M','U', &MD, Res);
      if (Res>=0) {
         List = (ListType*)malloc(sizeof(struct ListType));
         if (!List) {
            debug("kein Speicher, StartJourney, new TopLevel");
            return;
         }
         strcpy(List->File, StartFile);
         List->li=MD.li;
         List->re=MD.re;
         List->ob=MD.ob;
         List->un=MD.un;
         List->Zoom=1.0/(MD.re-MD.li);
         debug("Zoom=%0.5f",List->Zoom);
         List->cx=(MD.li+MD.re)*0.5;
         List->cy=(MD.un+MD.ob)*0.5;
         List->Next=NULL;
         List->Prev=NULL;
         FracType=MD.FractalType;
         EndePtr=List;
      } else {
         QMessageBox::information(this,i18n("Error"),
                         i18n("Topfile Read Error."),
                         i18n("OK"),0,0,0);
         return;
      }
   } else {
      QMessageBox::information(this,i18n("Error"),
                      i18n("Can not open TopFile."),
                      i18n("OK"),0,0,0);
      return;
   }
   delete Par;

   TestDir=InDir;
   TestDir.setNameFilter("*.par");
   for (Lauf=0; Lauf<TestDir.count(); Lauf++) {
      Par=new ParameterFile(InDir+TestDir[Lauf]);
      Res=Par->Open(PAR_READ);
      if (Res == PAR_OK) {
         Res=Par->BlockSize('M','U');
         if (Res>0) {
            Res = Par->ReadBlock('M','U', &MD, Res);
            if (Res==PAR_OK) {
               if (MD.FractalType==FracType) { // Typen sind gleich
               
                  double Z=1.0/(MD.re-MD.li);
                  double X=(MD.li+MD.re)*0.5;
                  double Y=(MD.un+MD.ob)*0.5;
                  
                  if ( Z>List->Zoom )     // ist grer
                  if ( (X>List->li) && (X<List->re) ) // X-Bereich
                  if ( (Y>List->un) && (Y<List->ob) ) 
                  { // Y-Bereich
                     //debug("ReadBlock  Res=%4d  Datei=%s",Res,(char*)TestDir[Lauf]);
                     
                     // Liste ist nach Zoomfaktoren sortiert,
                     // Einfgeposition suchen (Das erste Listenelement ist
                     // immer "StartFile")
                     Such=List;
                     while (Such) {
                        if (Such->Zoom>Z) break;
                        Such=Such->Next;
                     }
                     
                     // neues Element
                     Ptr = (ListType*)malloc(sizeof(struct ListType));
                     if (Ptr) {
                        strcpy(Ptr->File, InDir+TestDir[Lauf]);
                        Ptr->li=MD.li;
                        Ptr->re=MD.re;
                        Ptr->ob=MD.ob;
                        Ptr->un=MD.un;
                        Ptr->Zoom=Z;
                        debug("Zoom=%0.5f",Z);
                        Ptr->cx=X;
                        Ptr->cy=Y;
                        
                        // in Liste einbauen
                        if (Such) {  // Element einfgen
                           Such->Prev->Next=Ptr;
                           Ptr->Prev=Such->Prev;
                           Such->Prev=Ptr;
                           Ptr->Next=Such;
                        } else {     // Element anhngen
                           EndePtr->Next=Ptr;
                           Ptr->Next=NULL;
                           Ptr->Prev=EndePtr;
                           EndePtr=Ptr;
                        }
                     }
                  }
               }
            }
         }
      }
      delete Par;
   }
   MakeNames();   // Bildnamen erzeugen (Datei ohne Pfad und Endung)
   
   // Berechnung (Preview);
   Current=List;
//Client->update();
//    NoResize=TRUE;
//    NoResize=FALSE;
//   Client->AbortCalc(); 
//   Client->ImageReady=TRUE;
//   Client->Berechnung=FALSE;
//   for (Lauf=1; Lauf<100; Lauf++)
//     qApp->processEvents();
//      qApp->processEvents();
 
   debug("ImageReady = %s", (Client->ImageReady)?"True":"False");
   StoreColorMap();
   StopBtn->setEnabled(TRUE);
   CloseBtn->setEnabled(FALSE);
   Running=TRUE;
   Datei=new QString(Current->File);
   if (!kmand->LoadParamFile(Datei, TRUE)) {
        // Fehler LoadParam
      AbortJourney();
      return;
   }
   delete Datei;
//   Client->update();

   //testaus
/*   Ptr=List;
   while(Ptr) {
      debug("Zoom=%8.4f  Name=%s",Ptr->Zoom,Ptr->File);
      Ptr=Ptr->Next;
   }*/
   
/*   // Liste abbauen
   Ptr=List->Next;
   while(List) {
      free(List);
      List=Ptr;
      if (Ptr) Ptr=Ptr->Next;
   }*/
//    NoResize=FALSE;
}

void JourneyDlg::FertigSlot() {
QString *Datei;

   if (!Running) return;
   // if (!Client->ImageReady) return;
   
   //if (Client->height() != PrevYSpin->value()) {
   //   //Client->update();
   //   return;
   //}

   debug("Fhrtich!");
   MakeImage();
   if (Current->Next) {
      Current=Current->Next;
      Datei=new QString(Current->File);
      if (!kmand->LoadParamFile(Datei, TRUE)) {
         // Fehler LoadParam
         AbortJourney();
      }
      delete Datei;
      Client->update();
   } else {
      AbortJourney();  // 'normal' fertig
   }
}

void JourneyDlg::MakeImage(void) {
//QString S;
char Cmd[256];

   //S=Current->File;
   //S.truncate(S.length()-4);  // ".par" entfernen;
   //debug("S=%s",S.data());
   debug("File=%s",Current->File);
   
   // Zoomrechtecke einfgen
   if (Art==PREVIEW) {
      // Farbe fr die rechtecke reservieren
      //Client->ColorMap[255] = qRgb(255,255,255);  // letzte Farbe ist Wei
      //Client->InitPalette();   
      DataList.clear();
      Client->ConvertColors();
      DrawRects();
      // Html schreiben
      WriteHtml();
   }
      
   // Dateiname zum Speichern des BMP
   sprintf(Cmd,"%s%s.bmp", OutDir.data(), Current->Name);
   Client->SaveImage(Cmd);

   // Konvertierung  BMP->GIF
   if (Art==PREVIEW)
      sprintf(Cmd, "bmptoppm %s%s.bmp | ppmquant 256 | ppmtogif > %s%s.gif",
         OutDir.data(), Current->Name, OutDir.data(), Current->Name);
   else
      sprintf(Cmd, "bmptoppm %s%s.bmp | ppmquant 256 | ppmtogif > %s%sf.gif",
         OutDir.data(), Current->Name, OutDir.data(), Current->Name);
   system(Cmd);
   debug("CMD=%s",Cmd);
   
   // nicht mehr bentigtes BMP lschen
   sprintf(Cmd,"rm %s%s.bmp", OutDir.data(), Current->Name);
   system(Cmd);
}

int JourneyDlg::CheckRects(ListType *Ptr) {
ListType *Such;

   if (Ptr->Zoom > Current->Zoom) { // Zoomfaktor grer
      if ( (Ptr->cx > Current->li) && (Ptr->cx < Current->re) &&
           (Ptr->cy > Current->un) && (Ptr->cy < Current->ob) ) {
         Such = Current->Next;
         while (Such != Ptr) {
            if ( (Ptr->cx > Such->li) && (Ptr->cx < Such->re) &&
                 (Ptr->cy > Such->un) && (Ptr->cy < Such->ob) )
               return FALSE;  // Es gibt ein Zwischenbild, auf dem der
                              // Punkt ebenfalls sichtbar ist.
            Such=Such->Next;
         }
         return TRUE;
      } else
         return FALSE;
   }
   return FALSE;
}

void JourneyDlg::DrawRects(void) {
//Zoom-Rechtecke in das Preview-Bild einfgen
ListType* Ptr;
int x1,y1,x2,y2,h;

   debug("DrawRects");
   Ptr = Current->Next;
   while (Ptr) {
      if (CheckRects(Ptr)) {
         x1 = (int)(Client->GetSizeX()*(Ptr->li-Current->li)/(Current->re-Current->li));
         x2 = (int)(Client->GetSizeX()*(Ptr->re-Current->li)/(Current->re-Current->li));
         y1 = (int)(Client->GetSizeY()*(Ptr->un-Current->un)/(Current->ob-Current->un));
         y2 = (int)(Client->GetSizeY()*(Ptr->ob-Current->un)/(Current->ob-Current->un));
         // Mindestgre 4*3 Pixel
         if (x2-x1 < 4) {
            h= (x2+x1) >> 1;  // Mitte
            x1 = h-2;
            x2=h+2;
            h= (y2+y1) >> 1;
            y1 = h-1;
            y2 = h+2;
         }
         // Auf den sichtbaren Bereich begrenzen
         if (x1<0) x1=0;
         if (x2>=Client->GetSizeX()) x2=Client->GetSizeX()-1;
         if (y1<0) y1=0;
         if (y2>=Client->GetSizeY()) y2=Client->GetSizeY()-1;
         
         debug("Datei=%s x1=%d  y1=%d  x2=%d  y2=%d",Ptr->File,x1,y1,x2,y2);
         Client->DrawRect(x1,y1, x2-x1,y2-y1);
         Ptr->x1=x1; Ptr->y1=y1; Ptr->x2=x2; Ptr->y2=y2;
         DataList.append(Ptr);
      }
      Ptr=Ptr->Next;
   }
}

void JourneyDlg::WriteHtml(void) {
// HTML-Seite schreiben
char DateiName[256];
FILE *Html;
ListType *Ptr;

   debug("WriteHtml()");
   sprintf(DateiName, "%s%s.html", OutDir.data(),Current->Name);
   debug("File=%s",Current->File);

   Html=fopen(DateiName, "wt");

   fprintf(Html,"<HTML>\n<HEAD>\n");
   fprintf(Html,"<TITLE>Mandel Detail %s</TITLE>\n",Current->Name);
   fprintf(Html,"</HEAD>\n<BODY>\n");

   fprintf(Html,"<H1>%s Detail %s</H1>\n",Client->Fractal->GetFracName(),Current->Name);

   // Linkmap erzeugen
   fprintf(Html,"<MAP NAME=\"MandelMap\">\n");
   DataList.first();
   while (DataList.current()) {
      Ptr = DataList.current();
      fprintf(Html, "<AREA SHAPE=\"RECT\" COORDS=\"%d, %d, %d, %d\" HREF=\"%s.html\" TARGET=\"_top\">\n",
                    Ptr->x1, Ptr->y1, Ptr->x2, Ptr->y2, Ptr->Name);
      debug("Subfile=%s",Ptr->File);
      DataList.next();
   }
   fprintf(Html,"</MAP>\n");
   fprintf(Html,"<img ismap usemap=\"#MandelMap\" border=\"0\" src=\"%s.gif\" >\n",
              Current->Name);

   // Detaillinks erzeugen
   fprintf(Html,"<hr>\n");
   DataList.first();
   if (DataList.count() > 0) {
      fprintf(Html,i18n("Available Subdetails: \n"));
      while (DataList.current()) {
         Ptr = DataList.current();
         fprintf(Html, "<a href=\"%s.html\">%s</a>\n",Ptr->Name,Ptr->Name);
         debug("Subfile=%s",Ptr->File);
         DataList.next();
      }
      fprintf(Html,"<br>\n");
   }
   
   // bergeordnetes Bild suchen
   Ptr = Current->Prev;
   while (Ptr) {
      if ( (Ptr->li < Current->cx) && (Ptr->re > Current->cx) &&
           (Ptr->un < Current->cy) && (Ptr->ob > Current->cy) )
         break; // gefunden
      Ptr = Ptr->Prev;
   }
   if (Ptr)
      fprintf(Html,"Go up to <a href=\"%s.html\">%s</a>\n<br>\n",Ptr->Name,Ptr->Name);

   // Verweis auf Fullsize-Image
   if (FullCheck->isChecked()) {
      fprintf(Html, i18n("Full size image : <a href=\"%sf.gif\">%sf</a>\n<br>\n"),Current->Name,Current->Name);
   }

   fprintf(Html,"<hr>\n");
   fprintf(Html,"<FONT SIZE=-3>Journey created with kmandel by <a href=\"mailto:juergen.hochwald@privat.kkf.net\">jrgen.hochwald@privat.kkf.net</a></FONT>\n");

   fprintf(Html,"</BODY>\n</HTML>\n");

   fclose(Html);
}


void JourneyDlg::PrevSetClick() {
   Client->ColorDeep = 8;
//   Client->NumColors = 255;
   kmand->SetClientSize(PrevXSpin->value(), PrevYSpin->value());
}

void JourneyDlg::FullSetClick() {
   Client->ColorDeep = 8;
//   Client->NumColors = 255;
   kmand->SetClientSize(FullXSpin->value(), FullYSpin->value());
}

void JourneyDlg::PrevStartClick() {
QDir QD(OutDirEdit->text());

   if (QD.isReadable())
      StartJourney(PREVIEW);
   else
      QMessageBox::information(this,i18n("Error"),
                      i18n("Output-Dir dosn't exists."),
                      i18n("OK"),0,0,0);
}

void JourneyDlg::FullStartClick() {
QDir QD(OutDirEdit->text());

   if (QD.isReadable())
      StartJourney(FULL);
   else
      QMessageBox::information(this,i18n("Error"),
                      i18n("Output-Dir dosn't exists."),
                      i18n("OK"),0,0,0);
}

void JourneyDlg::MakeNames(void) {
ListType *Ptr;
QString Strg;

   Ptr = List;
   while (Ptr) {
      Strg = Ptr->File;
      Strg.truncate(Strg.length()-4);  // ".par" entfernen;
      Strg = Strg.mid(Strg.findRev('/')+1,20);
      debug("Name=%s",Strg.data());
      strcpy(Ptr->Name, Strg.data());
      Ptr=Ptr->Next;
   }
}

void JourneyDlg::StoreColorMap(void) {
// Farbtabelle zwischenspeichern
int i;

   for (i=0; i<255; i++)
      CMap[i] = Client->ColorMap[i];
}

void JourneyDlg::RestoreColorMap(void) {
// gespeicherte Farbtabelle wiederherstellen
int i;

   for (i=0; i<255; i++)
      Client->ColorMap[i] = CMap[i];
   Client->InitPalette();   
}

void JourneyDlg::StopBtnClick() {
   AbortJourney();
}

void JourneyDlg::AbortJourney(void) {
   Running = FALSE;
   RestoreColorMap();
   StopBtn->setEnabled(FALSE);
   CloseBtn->setEnabled(TRUE);
   Client->update();
}

void JourneyDlg::ReadmeBtnClick() {
   kapp->invokeHTMLHelp("kmandel/journey.html","");
}
