#ifndef LEC211_H
#define LEC211_H
#include <qwidget.h>
#include <qlabel.h>
#include <qpushbt.h>
#include <qdialog.h>
#include <qlined.h>
#include "basefrac.h"

class Lec211 : public BaseFract
{
public:
   virtual void Init(int SizeX, int SizeY);
   virtual void SetDefaultCorners(double *x1, double *x2, double *y1, double *y2);
   virtual double SetDefaultParams(int);
   virtual int GetFracClass(void) { return FC_ORBIT; }; // FracKlasse
   virtual void CalcOrbit(void);
   virtual const int GetFracType() { return FT_LEC211; }
   virtual const char* GetFracName(void) { return "Lec211 attractor"; }
   virtual const char* GetFracInfo(void);    // returns information on the fractal
   virtual int SetupFrac(BaseFract* Frac); // type specific-setup
private:
};

class Lec211Dlg : public QDialog
{
Q_OBJECT
public:
   Lec211Dlg(BaseFract* Frac, QWidget* parent=0, const char* name=0);
   int SetSpecificParams(void);
signals:

private slots:
   void SetDefaults();

private:
   BaseFract* Fractal;   // Pointer to the Fractal
   QLineEdit *ConstR, *ConstS, *ConstT, *ConstU;
};

#endif
