// Fraktaltyp Mand4
// p[0] = pixel.x
// p[1] = pixel.y
#include <stdio.h>
#include <stdlib.h>
#include <klocale.h>
#include "mand4.h"
#define MAND4PARNUM 4

double Mand4Par[MAND4PARNUM] = {1, 1, 1, 2};

void Mand4::Init(int SizeX, int SizeY)
{
int i;

   BaseFract::Init(SizeX, SizeY);
   SetDefaultCorners(&li,&re,&un,&ob);
   for (i=0; i<16;i++) p[i]=SetDefaultParams(i);
   SetSize(SizeX, SizeY);
}

void Mand4::SetDefaultCorners(double *x1, double *x2, double *y1, double *y2)
{
   *x1 = -2.5;     // Gre des Fraktals
   *x2 =  1.5;
   *y1 = -1.5;
   *y2 =  1.5;
}

double Mand4::SetDefaultParams(int Index)
{
   if (Index<0) return 0.0;
   if (Index >=  MAND4PARNUM) return 0.0;
   return Mand4Par[Index];
}

int Mand4::CalcPoint(int x, int y)
{
int    iter=0;
double rx = li+dx*x;
double ry = un+dy*y;
complex<double> c,z;
complex<double> a,b,d,f,g,h,j;
complex<double> eins=complex<double>(1,0);
//double A,B,C,D;

   c=complex<double>(rx,ry);
   a=complex<double>(p[0],0);
   b=complex<double>(p[1],0);
   d=complex<double>(p[2],0);
   f=complex<double>(p[3],0);
   g=eins/f;
   h=eins/d;
   j=eins/(f-b);
   z=pow((-a*b*g*h),j);
   do {
      z=(a*pow(z,b))+(d*pow(z,f))+c;
      iter++;
   } while ((iter<MaxIter) && ConvTest(z.real()*z.real(),z.imag()*z.imag()) );
//   } while ((iter<MaxIter) && (z.real()*z.real()+z.imag()*z.imag()<200) );
   return PostCompute(iter,z.real(),z.imag());
}
const char* Mand4::GetFracInfo(void)
{
   return 
"Formula: c=Pixel; a=p0; b=p1; d=p2; f=p3\n\
         g=1/f; h=1/d; j=1/(f-b); Z=(-a*b*g*h)^j;\n\
         c=Pickel;\n\
         z=(-a*b*g*h)^j;\n\
         loop {\n\
            z=(a*z^b + d*z^f) +c\n\
         } until (z^2>Bail)";
}

int Mand4::SetupFrac(BaseFract* Frac) // type specific-setup
{
GenericDlg GDlg(Frac, 0, "Mand4 settings");

   GDlg.SetHeader(i18n("Parameters p0-5"));
   GDlg.SetParameterNum(MAND4PARNUM);
   GDlg.SetParameterText(0,"p0");
   GDlg.SetParameterText(1,"p1");
   GDlg.SetParameterText(2,"p2");
   GDlg.SetParameterText(3,"p3");

   if (GDlg.exec()) {
      return GDlg.SetSpecificParams();
   } else
      return FALSE;
}
