// Fraktaltyp Mand4b
// p[0] = pixel.x
// p[1] = pixel.y
#include <stdio.h>
#include <stdlib.h>
#include <klocale.h>
#include "mand4b.h"

double Mand4bPar[6] = {100, 0.9, 101, -1.1, -0.985, 100};

void Mand4b::Init(int SizeX, int SizeY)
{
int i;

   BaseFract::Init(SizeX, SizeY);
   SetDefaultCorners(&li,&re,&un,&ob);
   for (i=0; i<16;i++) p[i]=SetDefaultParams(i);
   SetSize(SizeX, SizeY);
}

void Mand4b::SetDefaultCorners(double *x1, double *x2, double *y1, double *y2)
{
   *x1 = -3.5;     // Gre des Fraktals
   *x2 =  0.5;
   *y1 = -1.5;
   *y2 =  1.5;
}

double Mand4b::SetDefaultParams(int Index)
{
   if (Index<0) return 0.0;
   if (Index >= 6) return 0.0;
   return Mand4bPar[Index];
}

int Mand4b::CalcPoint(int x, int y)
{
int    iter=0;
double rx = li+dx*x;
double ry = un+dy*y;
complex<double> c,z;
complex<double> a,b,d,f,g,h,j,k,l;
complex<double> eins=complex<double>(1,0);
//double A,B,C,D;

   c=complex<double>(rx,ry);
   a=complex<double>(p[0],0);
   b=complex<double>(p[1],0);
   d=complex<double>(p[2],0);
   f=complex<double>(p[3],0);
   g=eins/f;
   h=eins/d;
   j=eins/(f-b);
   z=pow((-a*b*g*h),j);
   k=complex<double>(p[4],0)+1;
   l=complex<double>(p[5],0)+100;
   do {
      z=k*((a*pow(z,b))+(d*pow(z,f)))+c;
      iter++;
   } while ((iter<MaxIter) && ConvTest(z.real()*z.real(),z.imag()*z.imag()) );
//   } while ((iter<MaxIter) && (z.real()*z.real()+z.imag()*z.imag()<200) );
   return PostCompute(iter,z.real(),z.imag());
}
const char* Mand4b::GetFracInfo(void)
{
   return 
"Formula: c=Pixel; a=p0; b=p1; d=p2; f=p3\n\
         g=1/f; h=1/d; j=1/(f-b); Z=(-a*b*g*h)^j;\n\
         k=p4+1; l=p5+100; c=Pickel;\n\
         z=(-a*b*g*h)^j;\n\
         loop {\n\
            z=k*(a*z^b + d*z^f) +c\n\
         } until (z^2>Bail)";
}

int Mand4b::SetupFrac(BaseFract* Frac) // type specific-setup
{
GenericDlg GDlg(Frac, 0, "Mand4b settings");

   GDlg.SetHeader(i18n("Parameters p0-5"));
   GDlg.SetParameterNum(6);
   GDlg.SetParameterText(0,"p0");
   GDlg.SetParameterText(1,"p1");
   GDlg.SetParameterText(2,"p2");
   GDlg.SetParameterText(3,"p3");
   GDlg.SetParameterText(4,"p4");
   GDlg.SetParameterText(5,"p5");

   if (GDlg.exec()) {
      return GDlg.SetSpecificParams();
   } else
      return FALSE;
}
